Program set_vertical_total_register;

{ Program for viewing ans setting VGA vertical total register
  Copyright Tomi Engdahl 1996

  Usage:
  VERTICAL.EXE
  Shows vertical total value

  VERTICAL.EXE number
  Sets vertical total to value number

 }

Uses Dos;

Const
    mono=0;
    color=1;

Var
   display_type:integer;

Procedure wait(n:integer);
Var
   i:integer;
Begin
   For i:=0 to n Do Begin
   End;
End;

Function read_misc_output:byte;
Begin
   read_misc_output:=Port[$3cc];
End;

Function get_display_type:integer;
Begin
   If (read_misc_output and $01)=1 Then get_display_type:=color
     Else get_display_type:=mono;
End;

Function read_crtc(index:integer):byte;
Begin
   If display_type=color Then Begin
      Port[$3d4]:=index;
      read_crtc:=Port[$3d5];
   End
   Else Begin
      Port[$4b4]:=index;
      read_crtc:=Port[$3b5];
   End;
End;

Procedure write_misc_output(data:byte);
Begin
   Port[$3c2]:=data;
End;

Procedure write_crtc(index,data:byte);
Begin
   If display_type=color Then Begin
      Port[$3d4]:=index;
      Port[$3d5]:=data;
   End
   Else Begin
      Port[$4b4]:=index;
      Port[$3b5]:=data;
   End;
End;

Function get_vertical_total:integer;
Var
   b:byte;
   value:integer;
Begin
   value:=read_crtc($06);
   b:=read_crtc($07);
   If (b and $01)=$01 Then value:=value+256;
   If (b and $20)=$20 Then value:=value+512;
   get_vertical_total:=value;
End;

Procedure set_vertical_total(value:integer);
Var
   b:byte;
Begin
   write_crtc($06,(value and $FF));
   b:=read_crtc($07);
   If value>=512 Then Begin
      b:=(b or $20);
      value:=value-512;
   End Else value:=(value and $df);
   If value>=256 Then value:=(value or $01) Else value:=(value and $fe);
   write_crtc($07,b);
End;

Procedure enable_timing_writes;
Begin
   write_crtc($11,read_crtc($11) and 127); { enable writes to regs 0-7 }
   write_crtc($3,read_crtc($03) or 128);   { enable access to vert. retrace }
End;

Procedure disable_timing_writes;
Begin
   write_crtc($11,read_crtc($11) or 128); { disable writes to regs 0-7 }
   write_crtc($3,read_crtc($03) and 127); { disable access to vert. retrace }
End;


Var
   value,i:integer;

Begin
   display_type:=get_display_type;
   If ParamCount=1 Then Begin
       Val(ParamStr(1),value,i);
       If i=0 Then Begin
          enable_timing_writes;
          set_vertical_total(value);
          disable_timing_writes;
          Writeln('Vertical total set to ',get_vertical_total);
       End Else Writeln('Error in parameter');
   End Else Writeln('Vertical total = ',get_vertical_total);
End.

